local origOnLinkClicked
local AddMenuItem, ZO_Menu, ShowMenu 	= AddMenuItem, ZO_Menu, ShowMenu
local isEventRegistered             	= false
local numGuilds							= 0
local isdebug							= false

local function string_split(text, sep, pattern)
    local sep, fields = sep or " ", {}
    local patt = pattern or ("([^%s]+)"):format(sep)
    text:gsub(patt, function(c) fields[#fields+1] = c:lower() end)
    return fields
end

local function clearname(pname)
	local ret = pname:gsub("%^Mx","")
	ret = ret:gsub("%^Fx","")
	ret = ret:gsub("%^n","")
	ret = ret:gsub("%^p","")
	return ret
end

local function addPlayerToGuild(pname, guildid, guildname)
	d(string.format(Trans.GUILDINVITED,pname,guildname))
	GuildInvite(guildid,pname)
end

local function manualinvite(option)
    local options = {}
    local searchResult = { string.match(option,"^(%S*)%s*(.-)$") }
    for i,v in pairs(searchResult) do
        if (v ~= nil and v ~= "") then
            options[i] = v
        end
    end
	if #options == 0 or options[1] == "help" then
		d(Trans.HELP)
		d("/gin debug")
	elseif options[1] == "debug" then
		if isdebug then 
			isdebug=false 
			d("Debugging off")
		else 
			isdebug=true 
			d("Debugging on")
		end
	else
		local gid = GetGuildId(options[2])
		local guildName = GetGuildName(gid)
		addPlayerToGuild(options[1], gid, guildName)
	end
end

local function newOnLinkClicked(linkData, linkText, button, ...)
    origOnLinkClicked(linkData, linkText, button, ...)
	local ld = string_split(linkData,":")
	if isdebug then
		d("GuildInvite debugging:")
		for i,v in pairs(ld) do
			d(i..": "..v)
		end
		d("linktext: "..linkText)
	end	
	local namepart = string_split(ld[3],"^")
	if namepart[1] == nil then return end
	local pname = namepart[1]
	if isdebug then
		d("choosen name for invite: "..pname)
	end
    if button == 2 then
        ZO_Menu:SetHidden(true)
		numGuilds = GetNumGuilds()
		for i=1,numGuilds do
			local gid = GetGuildId(i)
			if(DoesPlayerHaveGuildPermission(gid,GUILD_PERMISSION_INVITE) == true) then
				local guildName = GetGuildName(gid)
				AddMenuItem(string.format(Trans.GUILDINVITE,guildName), function() addPlayerToGuild(pname, gid, guildName) end)
			end
		end
        ShowMenu(nil, 1)
    end
end

local function main()
    if not origOnLinkClicked then origOnLinkClicked = ZO_ChatSystem_OnLinkClicked end
	if not isEventRegistered then
		isEventRegistered = true
		ZO_ChatSystem_OnLinkClicked = newOnLinkClicked -- replace OnClick handler
	end
end

EVENT_MANAGER:RegisterForEvent("GuildInvite", EVENT_PLAYER_ACTIVATED, main)
SLASH_COMMANDS["/gin"] = manualinvite